#include <stdio.h>
#include <System.h>

using namespace System;
using RunTime::Array;

int main()
{
	IO::FileStream f;
	IO::IStream i;
	IO::OStream o;
	IO::IOStream io;

	printf("sizeof(*FileStream) == %lu\n", sizeof(*f));
	printf("sizeof(*IOStream) == %lu\n", sizeof(*io));
	printf("sizeof(*IStream) == %lu\n", sizeof(*i));

	printf("sizeof(FileStream) == %lu\n", sizeof(f));
	printf("sizeof(IOStream) == %lu\n", sizeof(io));
	printf("sizeof(IStream) == %lu\n", sizeof(i));
	
	i = f;
	io = IO::IOStream::downcast(i);
	
	if (!io)
		printf("io is null\n");
	else {
		uint8_t buf[256];
		Array<uint8_t> abuf(buf, 256);
		uint64_t len = 64;
		
		io.read(&abuf, &len);
		io.write(Array<uint8_t>(buf, 128), &len);
	}
	
	return 0;
}

uint64_t call1(IO::FileStream fs)
{
	uint64_t size;
	fs.size(&size);
	return size;
}

void call2(IO::FileStream fs)
{
	fs.seek(666, IO::FileStream_ns::SeekType::FromCurrent);
}

uint64_t call3(Mem::Cache c)
{
	uint64_t size;
	c.get_size(&size);
	return size;
}

uint64_t call4(Mem::Cache c)
{
	uint64_t size;
	c.get_size(&size);
	c.get_size(&size);
	return size;
}


uint64_t call5(Mem::Cache c)
{
	uint64_t size;
	Mem::Mappable m = c;
	m.get_size(&size);
	m = c;
	m.get_size(&size);
	return size;
}

uint64_t call6(Mem::Cache c)
{
	uint64_t size;
	Mem::Mappable m = c;
	m.get_size(&size);
	m.get_size(&size);
	return size;
}

//const unsigned long System::IO::_i_IOStream::guid[16] = {};
