#ifndef UTIL_H
#define UTIL_H

#include <iostream>
#include <stdint.h>

// Feed an indent struct into an ostream to get "indent_level" tabs
// and "align_spaces" spaces.

struct Indent {
	int indent_level;
	int align_spaces;
};

std::ostream &operator << (std::ostream &ostr, Indent &ind);

// Creates the specified directory, including all parent directories that
// do not yet exist.  Gives the user an error if any component could not
// be created, or (if require_empty is set) if the final directory is not
// empty.

void makepath(const char *path, bool require_empty = true);

// Turns an ASCII GUID into a binary GUID.  Prints a message
// and throws a UserError if the ASCII GUID is invalid.
// guid_bin must point to a 16-byte region of memory.

void parse_guid(const char *guid_str, char *guid_bin);

#endif
