// FIXME: This is out-of-date and incomplete.

#include <orb.h>

struct IFaceTable {
	const IFaceInfo *info;
	ptrdiff_t offset;
};

namespace System {
	struct _i_Object {
		static const unsigned char guid[];

		struct info_type {
			// The concrete field is used by the ORB to locate the
			// object ID (stored one word before the concrete pointer). 
			// The concrete field is zero except where multiple
			// inheritance causes there to be multiple table pointers in
			// the object.  When that happens, the concrete field is the
			// number of bytes (either 0 or negative) to add to the
			// pointer to yield a pointer to the most derived interface
			// (of which there can be only one).

			ptrdiff_t concrete;
			
			// This is a pointer to the most derived interface's
			// interface table, for use by a downcast method that does
			// not know the real type yet.
			
			::System::RunTime::IFaceTable *concrete_IFaceTable;
		
			// A list of interfaces follows.  Each entry in the list
			// consists of a pointer to the GUID for the entry's
			// interface, followed by an offset to add to a pointer of
			// this interface to obtain a pointer to this entry's
			// interface.  This list is scanned during downcast()
			// operations.  The entries are used directly (no scanning)
			// for upcast operations, and the first entry (which must be
			// the for this interface) is used by the ORB to verify the
			// GUID of objects passed.
			//
			// The offsets must be dynamic, because an interface can
			// only have one pointer regardless of how many times it is
			// inherited by an interface's parents, and thus the pointer
			// adjustment will not be the same for all pointers of the
			// same inner interface.
			//
			// For now, this table is ordered by the for_all_supers
			// traversal, but eventually it'd be nice to sort it
			// by GUID pointer (and yes, that change will break ABI
			// compatibility).

			::System::RunTime::IFaceTable System_IDLIDL_Object;
			
			// This is a NULL pointer to mark the end of the GUID
			// list.
			unsigned char *end;
			
			// Finally, the method pointers are provided.
			// There are currently no methods in System::Object.
			
			struct methods {
			} methods;
		};
		
		const info_type *info;
	};
	
	class Object {
		_i_Object *_ptr;
	
	public:
		Object()
		{
			_ptr = NULL;
		}
	
		Object(_i_Object *other)
		{
			_ptr = other;
		}
		
		operator _i_Object *()
		{
			return _ptr;
		}
	};
	

	namespace RunTime {
		template<typename T> struct Array {
			T *ptr;
			size_t count;
		
			bool valid_index(size_t index)
			{
				return index >= 0 && index < count;
			}
			
			T &operator[](size_t index)
			{
#ifndef NO_ARRAY_BOUNDS_CHECK
				if (!valid_index(index))
					throw SomeException();
#endif
		
				return ptr[index];
			}
		};

		uintptr_t downcast(::System::_i_Object *obj, unsigned char *new_guid)
		{
			IFaceTable *tbl = obj->info->concrete_IFaceTable;
			int index = 0, found_index = -1;
			
			while (tbl->guid != new_guid) {
				if (!tbl->guid)
					return NULL;

				tbl++;
			}
			
			uintptr_t ptr = (uintptr_t)obj;
			
			ptr += obj->info->concrete;
			ptr += tbl->offset;
			
			return ptr;
		};
	};

	struct NotifierInfo {
	};
};

namespace System { 
namespace IO {
	struct NotifierInfo : public ::System::NotifierInfo {
		uint64_t len;
		
		// Yuck.  Hack to work around broken enum-scoping and 
		// undefined enum-width.
		struct result {
			static const uint32_t Success = 0;
			static const uint32_t NoMoreData = 1;
			static const uint32_t NoMoreSpace = 2;
			static const uint32_t IOError = 3;
			static const uint32_t BadHandle = 4;
			static const uint32_t PipeClosed = 5;
			
			// Double yuck... Is there any sane way to avoid exposing
			// a leading underscore to the user, without potential conflicts
			// with enum values?  Perhaps "enumval" could be made a reserved
			// word...
			uint32_t _val;
		} result;
	};

	// Note the absence of "virtual"...  We don't want to use the
	// compiler's virtual table implementation, as we can't rely on it
	// to be compatible with any other language or compiler (or even
	// other versions of itself), and we also need the object ID to be
	// at a specific offset from the pointer.  We manage all virtual
	// table operations (including RTTI) ourselves.  Note that it is
	// an error if the compiler emits a virtual table (or anything
	// else not asked for) for any reason.

	// Unfortunately, this could deprive some compilers of optimization
	// information (such as for inlining when the concrete type is known
	// and the implementation is present in the same compilation unit).
	// A compiler which explicitly supports our standard vtable layout
	// could use alternate stub code that makes use of such support.
	
	struct _i_IStream {
		static const unsigned char guid[];
	
		struct info_type {
			// The info struct from the closest superinterface
			// which shares this pointer is included first.
			::System::_i_Object::info_type parent;

			struct iface_table {
				IFaceTable System_IDLIDL_IO_IDLIDL_IStream;
				IFaceTable System_IDLIDL_Object;
				unsigned char *_end;
			} iface_table;

			struct methods {
				void (*read)(::System::IO::_i_IStream *_this, 
				             Array<char, ::System::RunTime::ORBMM> *buf, uint64_t *len);
				
				void (*read_async)(::System::IO::_i_IStream *_this,
				                   Array<unsigned char, ::System::RunTime::ORBMM> *buf,
				                   ::System::Notifier *notifier);
			} methods;
		} info;
	};
	
	class IStream {
		_i_IStream *_ptr;
	
	public:
		void read(unsigned char &*buf, size_t &_count_buf, uint64_t &len)
		{
			_ptr->info->methods.read(this, buf, _count_buf, len);
		};

		void read_async(unsigned char *buf, size_t _count_buf,
		                ::System::Notifier *notifier)
		{
			_ptr->info->methods.read_async(this, buf, _count_buf, notifier);
		};
		
		IStream()
		{
			_ptr = NULL;
		}
	
		IStream(_i_IStream *other)
		{
			_ptr = other;
		}
		
		operator _i_IStream *()
		{
			return _ptr;
		}

		// Returns NULL if the downcast fails.  Upcasts never fail. 
		// "downcast" is (will be) a reserved word in IDL, or at least
		// in the C++ binding.

		static IStream downcast(::System::Object oldptr)
		{
			return IStream(reinterpret_cast<_i_IStream *>
				(::System::RunTime::downcast(oldptr, _i_IStream::guid)));
		}
		
		operator ::System::Object()
		{
			uintptr_t ptr = reinterpret_cast<uintptr_t>(this);
			ptr += _ptr->info->System_IDLIDL_Object.offset;
			return ::System::Object(reinterpret_cast<::System::_i_Object *>(ptr));
		}
	};

	struct OStream {
		static const unsigned char guid[];
	
		struct info_type {
			::System::Object::info parent;

			struct guid_table {
				unsigned char *System_IDLIDL_IO_IDLIDL_OStream;
				unsigned char *System_IDLIDL_Object;
				unsigned char *_end;
			} guids;
			
			struct cast_table {
				int32_t System_IDLIDL_IO_IDLIDL_OStream;
				int32_t System_IDLIDL_Object;
			} casts;

			struct methods {
				void (*write)(::System::IO::_i_OStream *_this, unsigned char *buf,
				              size_t *_count_buf, uint64_t *len);
				
				void (*write_async)(::System::IO::_i_OStream *this, unsigned char *buf,
				                    size_t count_buf, ::System::Notifier *notifier);
			} methods;
		};
		
		const info_type info;
		
		void write(unsigned char *buf, size_t _count_buf, uint64_t &len)
		{
			info->methods.write(this, buf, _count_buf, len);
		};

		void write_async(unsigned char *buf, size_t _count_buf,
		                 ::System::Notifier *notifier)
		{
			info->methods.write_async(this, buf, _count_buf, notifier);
		};
		
		static ::System::IO::OStream *downcast(::System::Object *obj)
		{
			return (::System::IO::OStream *)
				::System::RunTime::downcast(obj, ::System::IO::OStream::guid);
		}
		
		::System::Object *upcast(::System::Object *type)
		{
			uintptr_t ptr = (uintptr_t)this;
			ptr += info->casts.System_IDLIDL_Object;
			return (::System::Object *)ptr;
		}
	};


	struct _i_IOStream {
		static const unsigned char guid[];
	
		struct info_type {
			// Share a pointer with the left-most superinterface
			::System::IO::_i_IStream::info parent;

			struct guid_table {
				unsigned char *System_IDLIDL_IO_IDLIDL_IOStream;
				unsigned char *System_IDLIDL_IO_IDLIDL_IStream;
				unsigned char *System_IDLIDL_IO_IDLIDL_OStream;
				unsigned char *System_IDLIDL_Object;
				unsigned char *_end;
			} guids;
			
			struct cast_table {
				int32_t System_IDLIDL_IO_IDLIDL_IOStream;
				int32_t System_IDLIDL_IO_IDLIDL_IStream;
				int32_t System_IDLIDL_IO_IDLIDL_OStream;
				int32_t System_IDLIDL_Object;
			} casts;

			struct methods {
				void (*read)(::System::IO::_i_IStream *_this, 
				             Array<char, ::System::RunTime::ORBMM> *buf, uint64_t *len);
				
				void (*read_async)(::System::IO::_i_IStream *_this,
				                   Array<unsigned char, ::System::RunTime::ORBMM> *buf,
				                   ::System::Notifier *notifier);

				void (*write)(::System::IO::_i_OStream *_this, unsigned char *buf,
				              size_t *_count_buf, uint64_t *len);
				
				void (*write_async)(::System::IO::_i_OStream *this, unsigned char *buf,
				                    size_t count_buf, ::System::Notifier *notifier);
			} methods;
		}
		
		const info_type *info;
		
		::System::_i_OStream::info *info_System_IDLIDL_OStream;
	};
	
	class IOStream {
		_i_IOStream *_ptr;
	
	public:
		void read(unsigned char &*buf, size_t &_count_buf, uint64_t &len)
		{
			info->parent.methods.read(this, buf, _count_buf, len);
		};

		void read_async(unsigned char *buf, size_t _count_buf,
		                ::System::Notifier *notifier)
		{
			info->parent.methods.read_async(this, buf, _count_buf, notifier);
		};
		
		void write(unsigned char *buf, size_t _count_buf, uint64_t &len)
		{
			::System::OStream *thisptr = upcast((::System::Ostream *)NULL);
			info_System_IDLIDL_OStream.methods.write(this, buf, _count_buf, len);
		};

		void write_async(unsigned char *buf, size_t _count_buf,
		                 ::System::Notifier *notifier)
		{
			info_System_IDLIDL_OStream.methods.write_async
				(this, buf, _count_buf, notifier);
		};
		
		static ::System::IO::OStream *downcast(::System::Object *obj)
		{
			return (::System::IO::OStream *)
				::System::RunTime::downcast(obj, ::System::IO::OStream::guid);
		}
		
		::System::Object *upcast(::System::Object *type)
		{
			uintptr_t ptr = (uintptr_t)this;
			ptr += info->casts.System_IDLIDL_Object;
			return (::System::Object *)ptr;
		}
	};





	
	struct OStream : public ::System::Object {
		void write(unsigned char *buf, size_t _count_buf, uint64_t &len) = 0;
	};
	
	struct IOStream : public IStream, OStream {
	};
	
	struct FStream : public IOStream {
		void set_file(File *f) = 0;
		void get_file(File &*f) = 0;
		File *get_file() {
			File *ret;
			get_file(ret);
			return ret;
		};
	};
	
	
	
	


	class PhysAddrSpace {
	public:
	};

	struct Region {
		uint64_t start, len;
	};
	
	class MapHandle {
		void **_vtable;
	
	public:
		_inproc_MapHandle(void **vtable) : _vtable(vtable)
		{
			
		}
	
		void unmap(Region *regions, size_t count)
		{
		}
	};

	class _remote_MapHandle : public MapHandle {
	public:
		void unmap(Region *regions, size_t count)
		{
			
		}
	};

	// If implemented here, user supplies:
	class RealMapHandle : public MapHandle {
		void unmap(Region *regions, size_t count) {
			whatever
		}
	};
 	
	// This goes in a footer included in a non-header after the user's
	// header, or perhaps in an idlc-generated .cc file (which would
	// then need to know where the user's headers are located).
	void _entries_RealMapHandle() {
		// -Wno-pmf-conversions please...
		typedef void (*unmap)(RealMapHandle *, Region *, size_t);
	
		// x86:
		asm volatile(".global _entry_RealMapHandle\n"
		             "_entry_RealMapHandle:"
		             "pushl %%eax;"
		             "pushl %%ecx;"
		             "jmpl %0;" : : "i" ((unmap)&RealMapHandle::MapHandle));

		// alpha:
		// Need to make sure that the branch is within range, or
		// else use jmp.
		asm volatile(".global _entry_RealMapHandle\n"
		             "_entry_RealMapHandle:"
		             "ldq $a1, 0(%sp);"
		             "ldq $a2, 8(%sp);"
		             "br %0;" : : "i" ((unmap)&RealMapHandle::MapHandle));
	}
	
	// FIXME: probably use sections here instead of a global
	// constructor.  This way, initialization can be ordered,
	// and it'd be easier to extract a list of implemented
	// classes from the binary.
	
	class _init_RealMapHandle() {
	public:
		_init_RealMapHandle()
		{
			// register
		}
		
		~_init_RealMapHandle()
		{
			// deregister -- or don't bother because it's
			// the end of the program and it'll be unregistered
			// automatically anyway?
		}
	};
	
	_init_RealMapHandle _initinstance_RealMapHandle;
	
	// If not implemented here...
	
	class RealMapHandle : public MapHandle {
		void unmap(Region *regions, size_t count) {
			asm volatile("
		}
	};
 	
	
	
	
	class Mappable {
	public:
		uint64_t get_size() = 0;
		void get_size(uint64_t &size) = 0;
		
		uint64_t get_block_size() = 0;
		void get_block_size(uint64_t &block_size) = 0;

		
	};
}}
